package cn.superdesk.uniorder.dao.entity.thirdpart.qchjc.invoice;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class QchjcInvoiceApplyRelationEntityExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public QchjcInvoiceApplyRelationEntityExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdIsNull() {
            addCriterion("qchjc_invoice_apply_id is null");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdIsNotNull() {
            addCriterion("qchjc_invoice_apply_id is not null");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdEqualTo(Long value) {
            addCriterion("qchjc_invoice_apply_id =", value, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdNotEqualTo(Long value) {
            addCriterion("qchjc_invoice_apply_id <>", value, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdGreaterThan(Long value) {
            addCriterion("qchjc_invoice_apply_id >", value, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("qchjc_invoice_apply_id >=", value, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdLessThan(Long value) {
            addCriterion("qchjc_invoice_apply_id <", value, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdLessThanOrEqualTo(Long value) {
            addCriterion("qchjc_invoice_apply_id <=", value, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdIn(List<Long> values) {
            addCriterion("qchjc_invoice_apply_id in", values, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdNotIn(List<Long> values) {
            addCriterion("qchjc_invoice_apply_id not in", values, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdBetween(Long value1, Long value2) {
            addCriterion("qchjc_invoice_apply_id between", value1, value2, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andQchjcInvoiceApplyIdNotBetween(Long value1, Long value2) {
            addCriterion("qchjc_invoice_apply_id not between", value1, value2, "qchjcInvoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnIsNull() {
            addCriterion("invoice_apply_sn is null");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnIsNotNull() {
            addCriterion("invoice_apply_sn is not null");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnEqualTo(String value) {
            addCriterion("invoice_apply_sn =", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnNotEqualTo(String value) {
            addCriterion("invoice_apply_sn <>", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnGreaterThan(String value) {
            addCriterion("invoice_apply_sn >", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnGreaterThanOrEqualTo(String value) {
            addCriterion("invoice_apply_sn >=", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnLessThan(String value) {
            addCriterion("invoice_apply_sn <", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnLessThanOrEqualTo(String value) {
            addCriterion("invoice_apply_sn <=", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnLike(String value) {
            addCriterion("invoice_apply_sn like", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnNotLike(String value) {
            addCriterion("invoice_apply_sn not like", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnIn(List<String> values) {
            addCriterion("invoice_apply_sn in", values, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnNotIn(List<String> values) {
            addCriterion("invoice_apply_sn not in", values, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnBetween(String value1, String value2) {
            addCriterion("invoice_apply_sn between", value1, value2, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnNotBetween(String value1, String value2) {
            addCriterion("invoice_apply_sn not between", value1, value2, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityIsNull() {
            addCriterion("goods_quantity is null");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityIsNotNull() {
            addCriterion("goods_quantity is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityEqualTo(Integer value) {
            addCriterion("goods_quantity =", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityNotEqualTo(Integer value) {
            addCriterion("goods_quantity <>", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityGreaterThan(Integer value) {
            addCriterion("goods_quantity >", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_quantity >=", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityLessThan(Integer value) {
            addCriterion("goods_quantity <", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityLessThanOrEqualTo(Integer value) {
            addCriterion("goods_quantity <=", value, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityIn(List<Integer> values) {
            addCriterion("goods_quantity in", values, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityNotIn(List<Integer> values) {
            addCriterion("goods_quantity not in", values, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityBetween(Integer value1, Integer value2) {
            addCriterion("goods_quantity between", value1, value2, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andGoodsQuantityNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_quantity not between", value1, value2, "goodsQuantity");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountIsNull() {
            addCriterion("invoice_apply_amount is null");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountIsNotNull() {
            addCriterion("invoice_apply_amount is not null");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountEqualTo(BigDecimal value) {
            addCriterion("invoice_apply_amount =", value, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountNotEqualTo(BigDecimal value) {
            addCriterion("invoice_apply_amount <>", value, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountGreaterThan(BigDecimal value) {
            addCriterion("invoice_apply_amount >", value, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("invoice_apply_amount >=", value, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountLessThan(BigDecimal value) {
            addCriterion("invoice_apply_amount <", value, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("invoice_apply_amount <=", value, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountIn(List<BigDecimal> values) {
            addCriterion("invoice_apply_amount in", values, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountNotIn(List<BigDecimal> values) {
            addCriterion("invoice_apply_amount not in", values, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("invoice_apply_amount between", value1, value2, "invoiceApplyAmount");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("invoice_apply_amount not between", value1, value2, "invoiceApplyAmount");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}